import it.uniupo.graphLib.Edge;
import it.uniupo.graphLib.UndirectedGraph;

public class AllacciamentoIdrico {
    private UndirectedGraph mappa;
    private final int[][] costoScavo;
    private final int costoTubo;
    private final int puntoAllacciamento;


    public AllacciamentoIdrico(UndirectedGraph mappa, int[][] costoScavo, int costoTubo, int puntoAllacciamento) {
        this.mappa = mappa;
        this.costoScavo = costoScavo;
        this.costoTubo = costoTubo;
        this.puntoAllacciamento = puntoAllacciamento;
    }

    //Ai proprietari conviene Dijkstra, perché hanno il cammino minimo
    UndirectedGraph progettoProprietari() {
        Dijkstra dijkstra = new Dijkstra(mappa);
        return dijkstra.getDijkstraTree(puntoAllacciamento);
    }

    UndirectedGraph progettoComune() {
        //Uso l'MST ma non usi pesi normali ma uso il costo dello scavo
        UndirectedGraph mappaCostiScavi = (UndirectedGraph) mappa.create();
        for (int i = 0; i < costoScavo.length; ++i) {
            for (int j = 0; j < costoScavo[i].length; ++j) {
                if (i != j && costoScavo[i][j] != -1) {
                    if (!mappaCostiScavi.hasEdge(i, j)) {
                        mappaCostiScavi.addEdge(i, j, costoScavo[i][j]);
                    }
                }
            }
        }
        Prim prim = new Prim(mappaCostiScavi);
        return prim.getMST();
    }
}
